import { aws_iam as iam, RemovalPolicy } from 'aws-cdk-lib';
import { Construct } from 'constructs';
import { BedrockKnowledgeBaseProps, KnowledgeBaseConfiguration, DataSource, OpenSearchServerlessStorageConfiguration, RedisEnterpriseCloudStorageConfiguration, PineconeStorageConfiguration } from './interfaces';
export declare class BedrockKnowledgeBase extends Construct {
    readonly region: string;
    readonly name: string;
    readonly roleArn: string;
    readonly knowledgeBaseConfiguration?: KnowledgeBaseConfiguration;
    readonly storageConfiguration: OpenSearchServerlessStorageConfiguration | RedisEnterpriseCloudStorageConfiguration | PineconeStorageConfiguration;
    readonly dataSource: DataSource;
    readonly description?: string;
    readonly removalPolicy?: RemovalPolicy;
    readonly bedrockKnowledgeBaseCustomResourceRole: iam.Role;
    constructor(scope: Construct, name: string, props: BedrockKnowledgeBaseProps);
    private setKnowledgeBaseConfigurationDefaultValues;
    private setDataSourceDefaultValues;
}
